; 2005: Sept 19 - Read S3C from separate file

; CODE TO PICK UP SOME OBJECTS IN APPROPRIATE RATIO FROM 3C IN ORDER TO TEST FOR 6C
; THE RATIO IS TO BE THE SKY SREA RATIO OF 3C/6C: Area(3C) = 4.23 sr, Area(6C) = 0.102 sr

	pro make_smallSAMP

	print, ' In "make_smallSAMP.pro"'
 
;	S3C = 2096199                  ; CHECK SIZE OF 'tbirztageQ.dat' AND GIVE
;	S3C = 3355926

        SIZarr = lonarr(3)
; READ NUMBER OF LINES IN FILE 'tbirztageQ.dat' FROM 'SampSize3C6C7C.dat'
	openr, 1, '../../SampSize3C6C7C.dat'; Open the file
	readf, 1, SIZarr                    ; Read number of lines written in 'SampSize3C6C7C.dat'
	close, 1

	S3C = SIZarr[0]
;	print, ' S3C =', S3C, ', SIZarr =', SIZarr	

        alldata = DBLARR(4, S3C)       ; TOTAL SIZE / TOTAL # OF SOURCES present in simulation
        openr, 1, '../../BigRun/tbirztageQ.dat'
        readf, 1, alldata
        close, 1
 
        tbir3C = alldata(0, *)
        z3C = alldata(1, *)
	tage3C = alldata(2, *)
	Q3C = alldata(3, *)

	area3C = 4.23
	area6C = 0.102
	ratio3Cby6C = area3C / area6C   
        ; LENGTH OF INTERVAL NEEDED TO PICK UP AN 6C OBJECT FROM THE BIG SAMPLE ..
	S6C = S3C / ratio3Cby6C
	print, 'Length of 6C sample: S6C  =', S6C

        area7C = 0.022
        ratio3Cby7C = area3C / area7C
        ; LENGTH OF INTERVAL NEEDED TO PICK UP AN 6C OBJECT FROM THE BIG SAMPLE ..
        S7C = S3C / ratio3Cby7C
        print, 'Length of 7C sample: S7C  =', S7C
 	
	;openw, 1, 'check_counter.dat'
        ;printf, 1, 'counter  =', counter
        ;close, 1

	counter6C = dblarr(S6C+1)
	duplicate6C1 = dblarr(5000)
        duplicate6C2 = dblarr(5000)	

; FINDING OUT THE RANDOM INDICES WHICH TO PICK UP FOR THE 6C DETECTTION
	s6 = 0
	i = 0.0
	seed6C = S6C
	print, 'before loop, i =', i
	WHILE (i LT S6C) DO BEGIN
	   counter6C(i) = round(randomu(seed6C)*S3C)
	   for j=0.0, i-1.0 do begin
	      if (counter6C(i) EQ counter6C(j)) then begin
	         duplicate6C1(s6) = i
		 duplicate6C2(s6) = j
		 s6 = s6 + 1
	        ; counter(i) = randomu(seed)*S6C
	         i = i - 1.0
                 BREAK
	      endif
	      ;print, 'at ', i, 'RUN, counter =', counter(i)
	   endfor
	;   print, 'at ', i, '  RUN, counter6C =', counter6C(i), '   s6 = ', s6
	   i = i + 1.0
	ENDWHILE

; FINDING OUT THE RANDOM INDICES WHICH TO PICK UP FOR THE 7C DETECTTION
	counter7C = dblarr(S7C+1)
        duplicate7C1 = dblarr(500)
        duplicate7C2 = dblarr(500)
	s7 = 0
        i = 0.0
        print, 'before loop, i =', i
	seed7C = S7C

        WHILE (i LT S7C) DO BEGIN
           counter7C(i) = round(randomu(seed6C)*S3C)
           for j=0.0, i-1.0 do begin
              if (counter7C(i) EQ counter7C(j)) then begin
                 duplicate7C1(s7) = i
                 duplicate7C2(s7) = j
                 s7 = s7 + 1
                ; counter(i) = randomu(seed)*S6C
                 i = i - 1.0
                 BREAK
              endif
              ;print, 'at ', i, 'RUN, counter =', counter(i)
           endfor
         ;  print, 'at ', i, '  RUN, counter7C =', counter7C(i), '    s7 = ', s7
           i = i + 1.0
        ENDWHILE
	   
	tbir6C = tbir3C(counter6C)
	z6C = z3C(counter6C)
	tage6C = tage3C(counter6C)
	Q6C = Q3C(counter6C)

	tbir7C = tbir3C(counter7C)
        z7C = z3C(counter7C)
        tage7C = tage3C(counter7C)
        Q7C = Q3C(counter7C)

	openw, 1, 'tbirztageQ_6C.dat'
	for i=0L, S6C do begin
	   printf, 1, tbir6C(i), z6C(i), tage6C(i), Q6C(i)
	endfor
	close, 1 

	openw, 1, 'tbirztageQ_7C.dat'
        for i=0L, S7C do begin
           printf, 1, tbir7C(i), z7C(i), tage7C(i), Q7C(i)
        endfor
        close, 1

	alldata = DBLARR(1, S3C)       ; TOTAL SIZE / TOTAL # OF SOURCES present in simulation
        openr, 1, '../../BigRun/logP151_1pz.dat'
        readf, 1, alldata
        close, 1
        logP151t1pz_3C = alldata(0, *)

	logP151t1pz_6C = logP151t1pz_3C(counter6C)
	logP151t1pz_7C = logP151t1pz_3C(counter7C)

	openw, 1, 'logP151_1pz_6C.dat'
        for i=0L, S6C do begin
           printf, 1, logP151t1pz_6C(i)
	   ;printf, 1, z6C(i), D6C(i), logP151_6C(i)

        endfor
        close, 1

	openw, 1, 'logP151_1pz_7C.dat'
        for i=0L, S7C do begin
           printf, 1, logP151t1pz_7C(i)
	   ; printf, 1, z7C(i), D7C(i), logP151_7C(i)
        endfor
        close, 1

	;plot, z7C, psym=3, symsize = 0.5
        print, 'min(z6C) =', min(z6C), '	max(z6C) =', max(z6C)
	print, 'min(z7C) =', min(z7C), '        max(z7C) =', max(z7C)

	return
	end
