; 2005 : Paramita Barai : Combining codes in order to automate process
; July 20: Code to DETECT ALL 3C, 6C, 7C sources

; July 26 : Write as an IDL batch file.
;           This includes IDL executable statements only; NOT starting as pro etc.

	print, ' In "FluxLimit.pro"'

; RUN IDL CODE TO FIND SOURCES ABOVE 3C FLUX LIMIT (GIVEN BIG RUN SAMPLE FILES)
	.run detect_source_3C.pro
	detect_source_3C

; MAKE SMALLER SAMPLES (IN RATIO OF SKY AREAS) FOR TESTING 6C & 7C
	.run make_smallSAMP.pro
	make_smallSAMP

; RUN IDL CODES TO FIND SOURCES ABOVE 6C FLUX LIMIT
	.run find_DL_6C.pro
	find_DL_6C
	.run detect_source_6C.pro
	detect_source_6C

; RUN IDL CODES TO FIND SOURCES ABOVE 7C FLUX LIMIT
	.run find_DL_7C.pro
	find_DL_7C
	.run detect_source_7C.pro
	detect_source_7C
	
	spawn, 'rm -rf effec_dist_6C.dat'
	spawn, 'rm -rf effec_dist_7C.dat'

	spawn, 'gzip *.dat'
