; IDL CODE TO FIND ALPHA AT REST FRAME (SOURCE FRAME AS EMITTED) 151 MHz ..
; 2005 May 23: Update -- Calculate Dproj from D(t), if Dproj < 1kpc find Random Number again till Dproj > 1kpc
; July 20 : Update for combining processes -- Read SIZ variable from file
; Aug 01 : Change way of calculating random number in order to find projected size.
;          Incorporate something 'ARBITRARY' as the seed [nBRW = RANDOMU(ARBITRARY)]
;          Previous method seemed to be generating same random numbers every time

	pro find_alpha_rest_6C

        print, ' In "find_alpha_rest_6C.pro" :'

	SIZarr = intarr(2)
; READ NUMBER OF LINES IN FILE 'zTageQlogPem_noSmallD.dat' FROM 'SIZ_det.dat'
        openr, 1, 'SIZ_det.dat'    ; Open the file
        readf, 1, SIZarr           ; Read number of lines as written in 'SIZ_det.dat'
        close, 1
	SIZ = SIZarr[1]

	zlogP151M_t1pz = dblarr(3, SIZ)
        openr, 1, 'zlogP151_t1pz_D.dat'
        readf, 1, zlogP151M_t1pz
        close, 1
	logP151M_t1pz = zlogP151M_t1pz(1, *)
	
	zlogP151M = dblarr(3, SIZ)
        openr, 1, 'zlogP151_nu0_D.dat'
        readf, 1, zlogP151M
        close, 1
	z = zlogP151M(0, *)
	logP151M = zlogP151M(1, *)
	dkpc = zlogP151M(2, *)

	zlogP151M_by1pz = dblarr(3, SIZ)
        openr, 1, 'zlogP151_by1pz_D.dat'
        readf, 1, zlogP151M_by1pz
        close, 1
	logP151M_by1pz = zlogP151M_by1pz(1, *)

	x = dblarr(3)
	y = dblarr(3)
	openw, 2, 'a0a1a2.dat'
	openw, 3, 'alpha_Dproj.dat'

	for i = 0, SIZ-1 do begin
;	   nBRW = RANDOMU(i*10.0)  ;Result=RANDOMU(Seed) -- Here to get different seed 'i' is used

	   nBRW = RANDOMU(ARBITRARY)
	   DprojBRW = dkpc[i]*SQRT(nBRW*(2.0-nBRW));Projected Length - BRW random angle method
	   
	   count = 1.0               ; Setting random seed for later part (if Dproj < 1kpc)
	   WHILE (DprojBRW LT 1.0) DO BEGIN
	      print, ' DprojBRW < 1.0 kpc -- Do Again'
;	      nBRW = RANDOMU(count*10.0)

	      nBRW = RANDOMU(ARBITRARY)
	      DprojBRW = dkpc[i] * SQRT(nBRW*(2.0 - nBRW))
	      count = count + 1.0
	   ENDWHILE
; print, ' Final: dkpc =', dkpc[i], ',   nBRW =', nBRW, ',   DprojBRW =',  DprojBRW

	   x(0) = alog10(151.00 / (1.0 + z(i)))
	   y(0) = logP151M_by1pz(i)
	   x(1) = alog10(151.00)
           y(1) = logP151M(i)
	   x(2) = alog10(151.00 * (1.0 + z(i)))
           y(2) = logP151M_t1pz(i)

	   deg = 2       ; DEGREE OF POLYNOMIAL FIT .. THIS IS 2ND ORDER ..
	   RES = POLY_FIT(x, y, deg)
	   a1 = RES(1)
	   a2 = RES(2)
	   bet = -2.0*a2
           alph = -a1 + bet*alog10(151.00 / (1.0+z(i)))

	   printf, 2, RES(0), RES(1), RES(2)
	   printf, 3, alph, DprojBRW
	endfor

	close, 2
        close, 3

	return
        end

